<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_configlist.asp
' Summary  - View and edit configurations
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser(c_SUPERONLYACCESS)

' variable declaration
Dim int_pageid, str_pagetitle, str_filename, str_url, int_parentid, int_ordinal, bln_hide
Dim conn
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_admintemplate.asp"-->
<%
' end include files

' functions and subroutines
' Open config file and display configuration settings
Sub DoConfigList()
	
	Dim fs, f
	Dim str_config, str_configname, str_configvalue
	Dim arr_config
	Dim bln_string
	
	OpenFSO fs
	OpenFile "includes/acmsi_global.asp", fs, f
	Do While Not f.AtEndOfStream
		str_config = ReadOneLine(f)
		If (Left(str_config,8) = "const c_") AND Instr(str_config,"DATABASE")=0 Then
			str_config = Replace(str_config,"const c_","")
			arr_config = Split(str_config,"=")
			
			str_configname = Trim(arr_config(0))
			str_configvalue = Trim(arr_config(1))
			bln_string = False
			If Left(str_configvalue,1) = """" Then 
				str_configvalue = Mid(str_configvalue,2,Len(str_configvalue)-2)
				bln_string = True
			End If
			str_configvalue = Server.HTMLEncode(str_configvalue)
			
			Response.Write "<tr>" & vbCrLf
			Response.Write "	<th>" & str_configname & "</th>" & vbCrLf
			Response.Write "	<td>" &_
						"<input type=""text"" class=""textbox"" name=""" & str_configname & """ value=""" & str_configvalue & """ />" &_
						"<input type=""hidden"" name=""" & str_configname & "_isstring"" value=""" & bln_string & """ />" &_
						"</td>" & vbCrLf
			Response.Write "</tr>" & vbCrLf
		End If
	Loop
	CloseFile f
	CloseFSO fs
	
End Sub
' end functions and subroutines

' admin template areas
Sub DoMainAdminContent ()
	OpenDatabase conn
%>
	<div class="breadcrumb"><a href="acms_adminhome.asp"><%=GetLanguage("lang_administration")%>...</a>&nbsp; <%=GetLanguage("lang_configurations")%></div>
	<form method="post" action="acms_configaction.asp" name="frm_config">
		<input type="hidden" name="action" value="update" />
		<table class="form">
			<% DoConfigList %>
			<tr>
				<td>&nbsp;</td>
				<td>
					<input type="submit" name="submit" value="<%=GetLanguage("lang_update")%>" class="submitbtn" />
				</td>
			</tr>
		</table>
	</form>
<%
End Sub

Sub DoAdminInstructions ()
%>
	<h2><%=GetLanguage("lang_instructions")%></h2>
	<div id="instructions">
		<p>List above are the configuration options available in the "acmsi_global.asp" file.  If <strong>write</strong> permission
		has been set on the "includes" folder, the configuration file can be edited through this page.  However, editing the file
		directly will also work.</p>
		<p><strong>NOTE</strong>: For security reasons, database settings are not displayed for editing via the administration.</p>
	</div>
<%
End Sub
' end admin template areas
%>