<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_languageedit.asp
' Summary  - Edit language details
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser(c_SUPERONLYACCESS)

' variable declaration
Dim int_languageid, str_languagetitle, str_filename, str_keyword
Dim bln_disabled, str_disabledchecked
Dim str_action, str_submittext, str_breadcrumb
Dim conn
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_admintemplate.asp"-->
<%
' end include files

' content specific functions and subroutines
Sub DoLanguageFileList(filename)

	Dim str_selected
	Dim fs, folder, file_item
	
	ReadDirectory "language", fs, folder
	Response.Write "<select name=""filename"" onblur=""onblurvalidate(this);"">"
	Response.Write "	<option value=""""> --- " & GetLanguage("lang_selectfile") & " --- </option>" & vbCrLf
	For Each file_item In folder.Files
		str_selected = ""
		If file_item.Name = filename Then str_selected = " selected=""selected"""
		Response.Write "	<option value=""" & file_item.Name & """" & str_selected & ">" & file_item.Name & "</option>" & vbCrLf
	Next
	Response.Write "</select>"
	CloseFSO_Folder fs, folder

End Sub

Sub GetLanguageInformation ()
	
	Dim rs
	int_languageid = GetValue("id",0)
		
	If int_languageid = 0 Then
		str_action = "add"
		str_submittext = GetLanguage("lang_add")
		str_breadcrumb = GetLanguage("lang_addlanguage")
	Else
		str_action = "update"
		str_submittext = GetLanguage("lang_update")
		OpenRecordset q_SelectTable("*","acmstbl_languages","","","id",int_languageid,"number"), conn, rs
		If Not rs.EOF Then
			str_languagetitle = rs("title")
			str_breadcrumb = Server.HTMLEncode(str_languagetitle)
			str_filename = rs("filename")
			str_keyword = rs("keyword")
			bln_disabled = CBool(rs("disabled"))
			If bln_disabled Then str_disabledchecked = " checked=""checked"""
		End If
		CloseRecordset rs
	End If
	
End Sub

' Content
Sub DoMainAdminContent ()
	OpenDatabase conn
	GetLanguageInformation
%>
	<div class="breadcrumb"><a href="acms_adminhome.asp"><%=GetLanguage("lang_administration")%>...</a>&nbsp; <a href="acms_languagelist.asp"><%=GetLanguage("lang_languages")%>...</a>&nbsp; <%=str_breadcrumb%></div>
	<form method="post" action="acms_languageaction.asp" name="frm_lanaguage" onsubmit="return validate_language(this)">
		<input type="hidden" name="id" value="<%=int_languageid%>" />
		<input type="hidden" name="action" value="<%=str_action%>" />
		<table class="form">
			<tr>
				<th><%=GetLanguage("lang_title")%></th>
				<td><input type="text" name="title" value="<%=str_languagetitle%>" class="textbox" onblur="onblurvalidate(this);" /> *</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_keyword")%></th>
				<td><input type="text" name="keyword" value="<%=str_keyword%>" class="textbox" onblur="xmlvalidate('acmstbl_languages','id',form.id.value,'keyword',this);" /> *</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_filename")%></th>
				<td><% DoLanguageFileList str_filename %> *</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_disabled")%></th>
				<td><input type="checkbox" name="disabled"<%=str_disabledchecked%> value="True" /></td>
			</tr>
			<tr>
				<td>&nbsp;</td>
				<td>
					<input type="submit" name="submit" value="<%=str_submittext%>" class="submitbtn" />
				</td>
			</tr>
		</table>
	</form>
<%
	CloseDatabase conn
End Sub

Sub DoAdminInstructions ()
%>
	<h2><%=GetLanguage("lang_instructions")%></h2>
	<div id="instructions">
		<h3>Snippet Details</h3>
		<table class="tbl_instructions">
			<tr>
				<th><%=GetLanguage("lang_title")%></th>
				<td>The name of the language, and is displayed in the drop-down menu at the login page. <strong>Required</strong></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_keyword")%></th>
				<td>A simplified and unique name for the language utilising only alphanumerical characters (no spaces); 
				this is used as a reference. <strong>Required</strong></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_filename")%></th>
				<td>Filename of the language file in the "language" directory. <strong>Required</strong></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_disabled")%></th>
				<td>Disable the language; will not be available for selection at the login page.</td>
			</tr>
		</table>
	</div>
<%
End Sub
%>