<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_modulelist.asp
' Summary  - Displays a list of modules in the database
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser(c_SUPERONLYACCESS)

' variable declaration
Dim int_moduleid, str_moduletitle, str_modulekeyword, bln_disabled
Dim conn
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_admintemplate.asp"-->
<%
' end include files

' functions and subroutines
Sub DoModuleList()
	
	Dim str_languagetitle, str_tempmoduletitle
	Dim rs
	ExecuteRecordset q_SelectTable("id,title,keyword,disabled,version","acmstbl_modules","title","","","",""), conn, rs

	If Not rs.EOF Then
		Do Until rs.EOF
			int_moduleid = rs("id")
			str_moduletitle = rs("title")
			str_modulekeyword = rs("keyword")
			
			str_languagetitle = "lang_mod_" & str_modulekeyword
			str_tempmoduletitle = GetLanguage(str_languagetitle)
			If lcase(str_tempmoduletitle) <> lcase(str_languagetitle) Then str_moduletitle = str_tempmoduletitle
			
			If NotEmpty(rs("version")) Then str_moduletitle = str_moduletitle & " v" & rs("version")
			bln_disabled = CBool(rs("disabled"))
			
			Response.Write "<tr>" & vbCrLf
			DoDataOutput "acms_moduleedit.asp?id=" & int_moduleid,Server.HTMLEncode(str_moduletitle),"","maincol smlindent","td",""
			If bln_disabled Then
				DoDataOutput "acms_moduleaction.asp?id=" & int_moduleid & "&amp;action=enable","<img src=""images/admin/empty.gif"" alt=""" & GetLanguage("lang_enable") & """ title=""" & GetLanguage("lang_enable") & """ />","","icon","td",""
			Else
				DoDataOutput "acms_moduleaction.asp?id=" & int_moduleid & "&amp;action=disable","<img src=""images/admin/full.gif"" alt=""" & GetLanguage("lang_disable") & """ title=""" & GetLanguage("lang_disable") & """ />","","icon","td",""
			End If
			DoDataOutput "javascript:confirmdelete('acms_moduleaction.asp?id=" & int_moduleid & "&amp;action=delete','" & str_moduletitle & "')","<img src=""images/admin/cross.gif"" alt=""" & GetLanguage("lang_delete") & """ title=""" & GetLanguage("lang_delete") & """ />","","icon","td",""
			Response.Write "</tr>" & vbCrLf
			rs.MoveNext
		Loop
	End If
	
	CloseRecordset rs
	
End Sub

Sub DoMainAdminContent ()
	OpenDatabase conn
%>
	<div class="breadcrumb"><a href="acms_adminhome.asp"><%=GetLanguage("lang_administration")%>...</a>&nbsp; <%=GetLanguage("lang_modules")%></div>
	<table class="tree">
		<tr>
			<td colspan="3" class="add"><a href="acms_moduleedit.asp"><%=GetLanguage("lang_addmodule")%></a></td>
		</tr>
		<% DoModuleList %>
	</table>
<%
	CloseDatabase conn
End Sub

Sub DoAdminInstructions ()
%>
	<h2><%=GetLanguage("lang_instructions")%></h2>
	<div id="instructions">
		<p>Above shows a list of installed modules; click on the module name to edit the contents of the
		corresponding module. See below for explanations of the buttons shown in the module list.</p>
		<table class="tbl_instructions">
			<tr>
				<td><img src="images/admin/empty.gif" alt="Enable" title="Enable" width="15" height="15" /></td>
				<td>Indicates module is disabled; click to enable module</td>
			</tr>
			<tr>
				<td><img src="images/admin/full.gif" alt="Disable" title="Disable" width="15" height="15" /></td>
				<td>Indicates module is enabled; click to disable module</td>
			</tr>
			<tr>
				<td><img src="images/admin/cross.gif" alt="Delete" title="Delete" width="15" height="15" /></td>
				<td>Delete module from the database</td>
			</tr>
		</table>
	</div>
<%
End Sub
%>