<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_usergroupedit.asp
' Summary  - Edit details of the user group
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser("usergroups")

' variable declaration
Dim str_groupname, str_lockchecked
Dim int_usergroupid
Dim bln_locked
Dim str_action, str_submittext, str_breadcrumb
Dim conn
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_users.asp"-->
<!--#include file="includes/acmsi_admintemplate.asp"-->
<%
' end include files

Sub DoAccessAreaTree (usergroupid,parentid,level)

	Dim int_menuid, int_parentid
	Dim str_menutitle, str_filename, str_keyword
	Dim rs, rs_usergroup
	Dim str_menuchecked, str_languagetitle, str_tempmenutitle

	' Get details of page, based on parentid
	ExecuteRecordset q_SelectTable("*","acmstbl_menus","id","hide=" & GetBoolean(False),"parentid",parentid,"number"), conn, rs
	If Not rs.EOF Then
		Do Until rs.EOF
			' Put data into variables
			int_menuid = rs("id")
			str_menutitle = rs("title")
			str_filename = rs("filename")
			str_keyword = rs("keyword")
			int_parentid = rs("parentid")
			
			str_languagetitle = "lang_menu_" & str_keyword
			str_tempmenutitle = GetLanguage(str_languagetitle)
			If lcase(str_tempmenutitle) <> lcase(str_languagetitle) Then str_menutitle = str_tempmenutitle
			
			If NotEmpty(str_filename) Then
				OpenRecordset q_SelectTable("*","acmstbl_usergroupaccess","","usergroupid=" & usergroupid,"menukeyword",str_keyword,"string"), conn, rs_usergroup
				str_menuchecked = ""
				If Not rs_usergroup.EOF Then str_menuchecked = " checked=""checked"""
				CloseRecordset rs_usergroup
				
				Response.Write "<div style=""line-height:20px;"">"
				If NotEmpty(str_filename) Then Response.Write "<input type=""checkbox"" name=""menu"" value=""" & str_keyword & """" & str_menuchecked & " /> &nbsp; "
				Response.Write str_menutitle
				Response.Write "</div>" & vbCrLf
			ElseIf Not NotEmpty(str_filename) Then
				Response.Write "<div style=""line-height:20px;"">" & str_menutitle & "</div>" & vbCrLf
			End If
			DoAccessAreaTree usergroupid, int_menuid, level + 1 
			rs.MoveNext
		Loop
	End If
	
	CloseRecordset rs

End Sub

Sub DoModuleTree (usergroupid)

	Dim int_moduleid
	Dim str_moduletitle, str_keyword, str_filename
	Dim rs, rs_usergroup
	Dim str_menuchecked, str_languagetitle, str_tempmoduletitle

	' Get details of page, based on parentid
	ExecuteRecordset q_SelectTable("id,title,keyword,filename","acmstbl_modules","title","disabled=" & GetBoolean(False),"","",""), conn, rs
	If Not rs.EOF Then
		Response.Write "<div style=""line-height:20px;"">" & GetLanguage("lang_modules") & "</div>"
		Do Until rs.EOF
			' Put data into variables
			int_moduleid = rs("id")
			str_moduletitle = rs("title")
			str_filename = rs("filename")
			str_keyword = rs("keyword")
			
			str_languagetitle = "lang_mod_" & str_keyword
			str_tempmoduletitle = GetLanguage(str_languagetitle)
			If lcase(str_tempmoduletitle) <> lcase(str_languagetitle) Then str_moduletitle = str_tempmoduletitle
			
			If NotEmpty(str_filename) Then
				OpenRecordset q_SelectTable("*","acmstbl_usergroupaccess","","usergroupid=" & usergroupid,"menukeyword","mod_" & str_keyword,"string"), conn, rs_usergroup
				str_menuchecked = ""
				If Not rs_usergroup.EOF Then str_menuchecked = " checked=""checked"""
				CloseRecordset rs_usergroup
				
				Response.Write "<div style=""line-height:20px;"">"
				Response.Write "<input type=""checkbox"" name=""modules"" value=""mod_" & str_keyword & """" & str_menuchecked & " /> &nbsp; "
				Response.Write str_moduletitle
				Response.Write "</div>" & vbCrLf				
			End If
			rs.MoveNext
		Loop
	End If
	
	CloseRecordset rs

End Sub

Sub DoUserList()
	
	Dim str_username, bln_locked
	Dim rs, str_userclass
	
	ExecuteRecordset q_SelectTable("username,locked","acmstbl_users","super,username","super=" & GetBoolean(False),"usergroup",int_usergroupid,"number"), conn, rs
	If Not rs.EOF Then
		Do Until rs.EOF
			str_username = rs("username")
			bln_locked = CBool(rs("locked"))

			Response.Write "<tr>" & vbCrLf
			
			If (GetCookie("username") = str_username Or CheckUserPermissions("users")) Then
				DoDataOutput "acms_useredit.asp?username=" & str_username,Server.HTMLEncode(str_username),"","maincol smlindent" & str_userclass,"td",""
			Else
				DoDataOutput "",Server.HTMLEncode(str_username),"","maincol al nolink" & str_userclass,"td",""
			End If
			
			If bln_locked Then
				DoDataOutput "","<img src=""images/admin/empty.gif"" alt=""" & GetLanguage("lang_unhide") & """ title=""" & GetLanguage("lang_unhide") & """ />","","icon","td",""
			Else
				DoDataOutput "","<img src=""images/admin/full.gif"" alt=""" & GetLanguage("lang_hide") & """ title=""" & GetLanguage("lang_hide") & """ />","","icon","td",""
			End If
						
			Response.Write "</tr>" & vbCrLf
			rs.MoveNext
		Loop
	End If
	
	CloseRecordset rs
	
End Sub

Sub GetUserGroupInformation ()
	
	Dim rs
	int_usergroupid = GetValue("id",0)
	
	If int_usergroupid > 0 AND int_usergroupid = GetCookie("usergroup") Then SetError GetLanguage("lang_cannoteditusergroup"), "acms_usergrouplist.asp"
	If int_usergroupid = 0 Then
		str_action = "add"
		str_submittext = GetLanguage("lang_add")
		str_breadcrumb = GetLanguage("lang_addusergroup")
	Else
		str_action = "update"
		str_submittext = GetLanguage("lang_update")
		OpenRecordset q_SelectTable("*","acmstbl_usergroups","","","id",int_usergroupid,"number"), conn, rs
		If Not rs.EOF Then
			str_groupname = rs("groupname")
			str_breadcrumb = Server.HTMLEncode(str_groupname)
			bln_locked = CBool(rs("locked"))
			If bln_locked Then str_lockchecked = " checked=""checked"""
		End If
		CloseRecordset rs
	End If
	
End Sub

' Content
Sub DoMainAdminContent ()
	OpenDatabase conn
	GetUserGroupInformation
%>
	<div class="breadcrumb"><a href="acms_adminhome.asp"><%=GetLanguage("lang_administration")%>...</a>&nbsp; <a href="acms_usergrouplist.asp"><%=GetLanguage("lang_menu_usergroups")%>...</a>&nbsp; <%=str_breadcrumb%></div>
	<form method="post" action="acms_usergroupaction.asp" name="frm_usergroup" onsubmit="return validate_usergroup(this)">
		<input type="hidden" name="id" value="<%=int_usergroupid%>" />
		<input type="hidden" name="action" value="<%=str_action%>" />
		<table class="form">
			<tr>
				<th><%=GetLanguage("lang_groupname")%></th>
				<td><input type="text" name="groupname" value="<%=str_groupname%>" class="textbox" onblur="onblurvalidate(this);" /> *</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_locked")%></th>
				<td><input type="checkbox" name="locked"<%=str_lockchecked%> value="True" /></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_access")%></th>
				<td>
					<% 
						DoAccessAreaTree int_usergroupid, 0, 0 
						DoModuleTree int_usergroupid
					%>
				</td>
			</tr>
			<tr>
				<td>&nbsp;</td>
				<td>
					<input type="submit" name="submit" value="<%=str_submittext%>" class="submitbtn" />
				</td>
			</tr>
		</table>
	</form>
	<% If int_usergroupid > 0 Then %>
	<h2><%=GetLanguage("lang_menu_users")%></h2>
	<table class="tree">
		<% DoUserList %>
	</table>
	<% End If %>
<%
	CloseDatabase conn
End Sub

Sub DoAdminInstructions ()
%>
	<h2><%=GetLanguage("lang_instructions")%></h2>
	<div id="instructions">
		<table class="tbl_instructions">
			<tr>
				<th><%=GetLanguage("lang_groupname")%></th>
				<td>The name of the user group, and is mostly used just as an identifier in the admin. <strong>Required</strong></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_locked")%></th>
				<td>Lock all users in this group from accessing the administration.</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_access")%></th>
				<td>Select areas of the administration user will have access to.</td>
			</tr>
			
		</table>
	</div>
<%
End Sub
%>