<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_userlist.asp
' Summary  - Displays a list of users in the database
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************
OPTION EXPLICIT

Call ValidateUser("")

' variable declaration
Dim int_userid, str_username, bln_locked, bln_super
Dim conn
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_users.asp"-->
<!--#include file="includes/acmsi_admintemplate.asp"-->
<%
' end include files

' functions and subroutines
Sub DoUserList()
	
	Dim rs, str_userclass
	
	If GetCookie("super") Then
		ExecuteRecordset q_SelectTable("username,locked,super","acmstbl_users","super,username","","","",""), conn, rs
	Else
		ExecuteRecordset q_SelectTable("username,locked,super","acmstbl_users","username","","super",GetBoolean(False),"boolean"), conn, rs
	End If
	If Not rs.EOF Then
		Do Until rs.EOF
			str_username = rs("username")
			bln_locked = CBool(rs("locked"))
			bln_super = CBool(rs("super"))
			If bln_super Then 
				str_userclass = " highlight"
			Else
				str_userclass = ""
			End If

			Response.Write "<tr>" & vbCrLf
			
			If bln_super AND GetCookie("super") Then
				DoDataOutput "acms_useredit.asp?username=" & str_username,Server.HTMLEncode(str_username),"","maincol smlindent" & str_userclass,"td",""
			ElseIf (GetCookie("username") = str_username Or CheckUserPermissions("users")) AND Not bln_super Then
				DoDataOutput "acms_useredit.asp?username=" & str_username,Server.HTMLEncode(str_username),"","maincol smlindent" & str_userclass,"td",""
			Else
				DoDataOutput "",Server.HTMLEncode(str_username),"","maincol al nolink" & str_userclass,"td",""
			End If
			
			If str_username = GetCookie("username") Then
				DoDataOutput "","&nbsp;","","icon","td",""
			ElseIf bln_super AND GetCookie("super") Then
				If bln_locked Then
					DoDataOutput "acms_useraction.asp?username=" & str_username & "&amp;action=unlock","<img src=""images/admin/empty.gif"" alt=""" & GetLanguage("lang_unhide") & """ title=""" & GetLanguage("lang_unhide") & """ />","","icon","td",""
				Else
					DoDataOutput "acms_useraction.asp?username=" & str_username & "&amp;action=lock","<img src=""images/admin/full.gif"" alt=""" & GetLanguage("lang_hide") & """ title=""" & GetLanguage("lang_hide") & """ />","","icon","td",""
				End If
			ElseIf (str_username <> GetCookie("username") And CheckUserPermissions("users")) And Not bln_super Then
				If bln_locked Then
					DoDataOutput "acms_useraction.asp?username=" & str_username & "&amp;action=unlock","<img src=""images/admin/empty.gif"" alt=""" & GetLanguage("lang_unhide") & """ title=""" & GetLanguage("lang_unhide") & """ />","","icon","td",""
				Else
					DoDataOutput "acms_useraction.asp?username=" & str_username & "&amp;action=lock","<img src=""images/admin/full.gif"" alt=""" & GetLanguage("lang_hide") & """ title=""" & GetLanguage("lang_hide") & """ />","","icon","td",""
				End If
			Else
				DoDataOutput "","&nbsp;","","icon","td",""
			End If
			
			If str_username = GetCookie("username") Then
				DoDataOutput "","&nbsp;","","icon","td",""
			ElseIf bln_super AND GetCookie("super") Then
				DoDataOutput "javascript:confirmdelete('acms_useraction.asp?username=" & str_username & "&amp;action=delete','" & str_username & "')","<img src=""images/admin/cross.gif"" alt=""" & GetLanguage("lang_delete") & """ title=""" & GetLanguage("lang_delete") & """ />","","icon","td",""
			ElseIf (str_username <> GetCookie("username") And CheckUserPermissions("users")) And Not bln_super Then
				DoDataOutput "javascript:confirmdelete('acms_useraction.asp?username=" & str_username & "&amp;action=delete','" & str_username & "')","<img src=""images/admin/cross.gif"" alt=""" & GetLanguage("lang_delete") & """ title=""" & GetLanguage("lang_delete") & """ />","","icon","td",""
			Else
				DoDataOutput "","&nbsp;","","icon","td",""
			End If
			
			Response.Write "</tr>" & vbCrLf
			rs.MoveNext
		Loop
	End If
	
	CloseRecordset rs
	
End Sub
' end functions and subroutines

' admin template areas
Sub DoMainAdminContent ()
	OpenDatabase conn
%>
	<div class="breadcrumb"><a href="acms_adminhome.asp"><%=GetLanguage("lang_administration")%>...</a>&nbsp; <%=GetLanguage("lang_menu_users")%></div>
	<table class="tree">
		<tr>
			<td colspan="3" class="add"><a href="acms_useredit.asp"><%=GetLanguage("lang_adduser")%></a></td>
		</tr>
		<% DoUserList %>
	</table>
<%
	CloseDatabase conn
End Sub

Sub DoAdminInstructions ()
%>
	<h2><%=GetLanguage("lang_instructions")%></h2>
	<div id="instructions">
		<p>Above shows a list of users that have been created; click on the page name to edit the contents of the
		corresponding page. Super users are highlighted in green.</p>
		<table class="tbl_instructions">
			<tr>
				<td><img src="images/admin/empty.gif" alt="Unhide" title="Unhide" width="15" height="15" /></td>
				<td>Indicates user is currently locked; click to unlock the user</td>
			</tr>
			<tr>
				<td><img src="images/admin/full.gif" alt="Hide" title="Hide" width="15" height="15" /></td>
				<td>Indicates user is currently unlocked; click to lock the user</td>
			</tr>
			<tr>
				<td><img src="images/admin/cross.gif" alt="Delete" title="Delete" width="15" height="15" /></td>
				<td>Delete user; user cannot delete oneself, non-super users cannot delete super users</td>
			</tr>
		</table>
	</div>
<%
End Sub
' end admin template areas
%>