<%
' *******************************************************************************
' AtomatiCMS
' Filename - acmsinstall.asp
' Summary  - Installs and set up AtomatiCMS
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

' variable declaration
Dim str_username, str_password, str_dbtype
Dim str_submit, str_breadcrumbs
Dim conn
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_admintemplate.asp"-->
<%
' end include files

' content specific functions and subroutines
Sub OpenInstallDatabase(conn)

	Dim str_dbname, str_dblocation, str_userid, str_userpwd
	Dim str_connection
	
	str_dbname = GetFormValue("dbname","")
	str_dblocation = GetFormValue("dblocation","")
	str_userid = GetFormValue("dbuserid","")
	str_userpwd = GetFormValue("dbuserpassword","")
	
	If str_dbtype = "" OR str_dbname = "" OR str_dblocation = "" Then SetError GetLanguage("lang_incompletedatabasedetails"), "acmsinstall.asp"
	
	Select Case lcase(str_dbtype)
	
		Case "access","access2007"
			If Instr(str_dblocation,":") > 0 Then
				str_dblocation = str_dblocation & "\" & str_dbname
			ElseIf NotEmpty(str_dblocation) Then 
				str_dblocation = Server.MapPath(str_dblocation & "\" & str_dbname)
			End If
			
			If lcase(str_dbtype) = "access" Then
				str_connection = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & str_dblocation & ";"
			Else
				str_connection = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source=" & str_dblocation & ";"
			End If
			If NotEmpty(str_userpwd) Then 
				str_connection = str_connection & "Jet OLEDB:Database Password=" & str_userpwd & ";"
			Else
				str_connection = str_connection & "Persist Security Info=False;"
			End If
				
		Case "mysql"
			str_connection = "Driver={MYSQL ODBC 3.51 Driver};Server=" & str_dblocation & ";Database=" & str_dbname & ";UID=" & str_userid & ";PWD=" & str_userpwd & ";OPTION=3;"
			
		Case "sqlserver"
			str_connection = "Driver={SQL Server};Server=" & str_dblocation & ";Database=" & str_dbname & ";UID=" & str_userid & ";PWD=" & str_userpwd & ";"
		
		Case Else
	
	End Select
	Set conn = Server.CreateObject("ADODB.Connection")
	conn.ConnectionTimeout = 20
	On Error Resume Next
	conn.Open(str_connection)
	If Err.Number <> 0 then
		SetError Err.Description, "acmsinstall.asp"
		Error.Clear
	End If

End Sub

Sub InstallFile(filename)

	Dim str_install, str_query
	Dim arr_queries, arr_query
	Dim i, rs, str_error
	
	If NotEmpty(filename) Then
		str_install = Replace(ReadFile(filename),vbCrLf," ")
		arr_queries = Split(str_install,";")
		For i = 0 To Ubound(arr_queries)
			str_query = arr_queries(i)
			If NotEmpty(str_query) Then 
				arr_query = Split(Trim(Lcase(str_query))," ")
				If IsArray(arr_query) Then
					On Error Resume Next
					If arr_query(0) = "create" AND arr_query(1) = "table" Then conn.Execute("drop table " & arr_query(2))
					Error.Clear
				End If
				conn.Execute(str_query)
			End If
		Next
	End If

End Sub

Sub CreateRecords()
	
	str_username = GetValue("username","")
	str_password = GetValue("password","")
	str_dbtype = GetFormValue("dbtype","")
	
	If str_username = "" OR str_password = "" Then GetLanguage("lang_usernamerequired") & "/" & GetLanguage("lang_passwordrequired"), "acmsinstall.asp"

	OpenInstallDatabase conn	
	Select Case lcase(str_dbtype)
		
		Case "access","access2007"
			q_InsertUser conn,str_username,str_password,True,0,False
			
		Case "sqlserver"
			InstallFile "acmsinstall_sqlserver.txt"
			q_InsertUser conn,str_username,str_password,True,0,False
			
		Case "mysql"
			InstallFile "acmsinstall_mysql.txt"
			q_InsertUser conn,str_username,str_password,True,0,False
	
	End Select
	CloseDatabase conn
	
		
End Sub

Sub DoMainAdminContent ()
	str_submit = GetValue("submit","")	
	If str_submit = "" Then
%>
	<div class="breadcrumb"><a href="acmsinstall.asp">Installation</a></div>
	<form method="post" action="acmsinstall.asp" name="frm_install">
		<h2>Step 1: Configurations</h2>
		<table class="form" style="line-height:20px">
			<tr>
				<td colspan="2">
					<p>Enter the database details in the "acmsi_global.asp" file of the "includes" directory.</p>
					<p><strong>c_DATABASETYPE :</strong> "access", "access2007", "sqlserver", or "mysql"<br />
					<strong>c_DATABASENAME :</strong> Filename (include file extension) of Access database; name of the database for SQL Server/MySQL<br />
					<strong>c_DATABASELOCATION :</strong> Relative/absolute path to Access database; server/IP address of SQL Server/MySQL database<br />
					<strong>c_DATABASEID :</strong> Not required for Access; user ID to access SQL Server/MySQL database<br />
					<strong>c_DATABASEPWD :</strong> Password to access database; optional for Access, only use when it is protected using the "Set Database Password" function</p>
					
					<p>For the "Access" database, check that the directory where the database is located has been given read/write permission.<br />
					While for SQL Server and MySQL, check that the user entered in the configurations file has read/write permission to
					the database.<br />Please confirm with your web host if you are unsure.</p>
					
					<p>Due to security reasons, the installation file will not use the values entered in the aforementioned file,
					please re-enter them in the fields below.</p>
				</td>
			</tr>
			<tr>
				<th>Database Type</th>
				<td><select name="dbtype">
						<option value="access">Access</option>
						<option value="access2007">Access 2007</option>
						<option value="sqlserver">SQL Server</option>
						<option value="mysql">MySQL</option>
					</select> *
				</td>
			</tr>
			<tr>
				<th>Database Name</th>
				<td><input type="text" name="dbname" class="textbox" onblur="onblurvalidate(this);" /> *</td>
			</tr>
			<tr>
				<th>Database Location/Server</th>
				<td><input type="text" name="dblocation" class="textbox" onblur="onblurvalidate(this);" /> *</td>
			</tr>
			<tr>
				<th>User ID</th>
				<td><input type="text" name="dbuserid" class="textbox" /></td>
			</tr>
			<tr>
				<th>User Password</th>
				<td><input type="text" name="dbuserpassword" class="textbox" /></td>
			</tr>
		</table>
		<h2>Step 2: Setup Database and Create Administration User</h2>
		<table class="form" style="line-height:20px;">
			<tr>
				<td colspan="2">
					<p>For MySQL and SQL Server, the installer will create the database tables; Access does not need to undertake this process.<br />
					However, an administration user needs to be created to access the AtomatiCMS administration.<br />
					Enter the desired username and password in the form below:</p> 
				</td>
			</tr>
			<tr>
				<th>Username</th>
				<td><input type="text" name="username" class="textbox" onblur="onblurvalidate(this);" /> *</td>
			</tr>
			<tr>
				<th>Password</th>
				<td><input type="text" name="password" class="textbox" onblur="onblurvalidate(this);" /> *</td>
			</tr>
			<tr>
				<td>&nbsp;</td>
				<td>
					<input type="submit" name="submit" value="Install" class="submitbtn" />
				</td>
			</tr>
		</table>
<%
	Else
		CreateRecords
%>
		<table class="form">
			<tr>
				<td>
					<h2>Congratulations! You have successfully installed AtomatiCMS.</h2>
					<p>It is important that this file "acmsinstall.asp" is deleted from the server <strong>immediately</strong>.</p>
					<p>Your login details are:<br />
					<strong>Username:</strong> <%=str_username%><br />
					<strong>Password:</strong> <%=str_password%></p>
					<p><a href="<%=c_LOGINPAGE%>">Click here to log into administration</a></p>
				</td>
			</tr>
		</table>
	</form>
<%
	End If
End Sub

Sub DoAdminInstructions ()

End Sub
%>