<%
' *******************************************************************************
' AtomatiCMS
' Filename - acmsf_files.asp
' Summary  - File (FSO) related functions and subroutines
' Version  - 0.7B
' Updated  - 28 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

Sub OpenFSO(fs)

	Set fs = CreateObject("Scripting.FileSystemObject")
	
End Sub

Sub CloseFSO(fs)

	Set fs = Nothing
	
End Sub

Sub CloseFSO_Folder(fs,folder)
	
	Set fs = Nothing
	Set folder = Nothing

End Sub

Sub ReadDirectory(invalue,fs,folder)

	On Error Resume Next
	Set fs = CreateObject("Scripting.FileSystemObject")
	If InStr(invalue,":") = 0 Then
		Set folder = fs.GetFolder(Server.MapPath(invalue))
	Else
		Set folder = fs.GetFolder(invalue)
	End If
	If Err.Number <> 0 then
		WriteSession "adminerror", GetLanguage("lang_directorydoesnotexist")
		Error.Clear
	End If
			
End Sub

Sub OpenFile(invalue,fs,fo)

	Dim str_filepath
	
	If InStr(invalue,":") > 0 Then
		str_filepath = invalue
	Else
		str_filepath = Server.MapPath(invalue)
	End If
	
	If fs.FileExists(str_filepath) Then
		Set fo=fs.OpenTextFile(str_filepath, 1)
	Else
		WriteSession "adminerror", GetLanguage("lang_filenotfound")
	End If

End Sub

Sub CloseFile(fo)

	fo.Close
	Set fo = Nothing

End Sub

Function ReadOneLine(fo)

	Dim outvalue
	outvalue = fo.ReadLine
	ReadOneLine = outvalue

End Function

Function ReadFile(infile)

	Dim fso, str_filepath, stream, outvalue
	
	Set fso = Server.CreateObject("Scripting.FileSystemObject")
	If InStr(infile,":") > 0 Then
		str_filepath = infile
	Else
		str_filepath = Server.MapPath(infile)
	End If

	If fso.FileExists(str_filepath) Then
		On Error Resume Next
		Set stream = fso.OpenTextFile(str_filepath, 1, False, -2)
		outvalue = stream.ReadAll
		If Err.Number <> 0 then
			SetError "adminerror", Error.Description
			Error.Clear
		End If
		CloseFile stream
	Else
		outvalue = ""
	End If
	CloseFSO fso
	ReadFile = outvalue

End Function

Sub WriteFile(infile,invalue)

	Dim fso, str_filepath, outfile
	
	Set fso = Server.CreateObject("Scripting.FileSystemObject")
	If InStr(infile,":") > 0 Then
		str_filepath = infile
	Else
		str_filepath = Server.MapPath(infile)
	End If
	CreateDirectory infile, fso, True
	On Error Resume Next
	Set outfile = fso.CreateTextFile(str_filepath,1)
	outfile.WriteLine(invalue)
	CloseFile outfile
	CloseFSO fso
	If Err.Number <> 0 then
		WriteSession "adminerror", GetLanguage("lang_permissiondeniedfilenotcreated")
		Error.Clear
	End If

End Sub

Sub DeleteFile(infile)

	Dim fso
	Set fso = Server.CreateObject("Scripting.FileSystemObject")
	On Error Resume Next
	fso.DeleteFile(Server.MapPath(infile))
	If Err.Number <> 0 then
		WriteSession "adminerror", GetLanguage("lang_permissiondeniedfilenotdeleted")
		Error.Clear
	End If
	CloseFSO fso 

End Sub

Sub CreateDirectory(infile,fs,includesfilename)

	Dim arr_directory, str_directory
	Dim f, i
	
	If includesfilename Then
		arr_directory = Split(infile,"/")
		If Ubound(arr_directory) > 0 Then
			For i = 0 to Ubound(arr_directory)-1
				str_directory = str_directory & arr_directory(i) & "/"
			Next
		Else
			arr_directory = Split(infile,"\")
			For i = 0 to Ubound(arr_directory)-1
				str_directory = str_directory & arr_directory(i) & "/"
			Next
		End If
	Else
		str_directory = infile
	End If

	If NotEmpty(str_directory) AND Instr(str_directory,":") = 0 Then str_directory = Server.MapPath(str_directory)
	
	If NotEmpty(str_directory) Then
		If Not fs.FolderExists(str_directory) then
			On Error Resume Next
			Set f = fs.CreateFolder(str_directory)
			If Err.Number <> 0 then
				WriteSession "adminerror", GetLanguage("lang_permissiondeniedfilenotcreated")
				Error.Clear
			End If
		End If
	End If
	
End Sub


Function RemoveUnsafeDirChars(invalue)

	Dim outvalue
	
	outvalue = invalue
	If NotEmpty(outvalue) Then
		outvalue = Replace(outvalue,".","")
		outvalue = Replace(outvalue,"/","")
		outvalue = Replace(outvalue,"\","")
		outvalue = Replace(outvalue,":","")
		outvalue = Replace(outvalue,"*","")
		outvalue = Replace(outvalue,"|","")
		outvalue = Replace(outvalue,"<","")
		outvalue = Replace(outvalue,">","")
		outvalue = Replace(outvalue,"?","")
		outvalue = Replace(outvalue,"""","")
	End If
	
	RemoveUnsafeDirChars = outvalue

End Function
%>