<%
' *******************************************************************************
' AtomatiCMS
' Filename - acmsf_input.asp
' Summary  - Input functions and subroutines
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

Function GetFormValue(invalue,default)

	Dim outvalue
	outvalue = Request.Form(invalue)
	If IsNull(outvalue) OR outvalue = "" Then outvalue = default
	GetFormValue = outvalue
	
End Function

Function GetJSValue(invalue)

	Dim outvalue
	outvalue = invalue
	outvalue = Replace(outvalue,"""","\""")
	outvalue = Replace(outvalue,vbCrLf,"\n")
	outvalue = Replace(outvalue,"</","<""+""/" )
	GetJSValue = outvalue
	
End Function

Sub GetRegExpMatches(pattern,invalue,obj)

	Dim obj_regexp
	
	Set obj_regexp = new RegExp
	obj_regexp.Pattern = pattern
	obj_regexp.IgnoreCase = True
	obj_regexp.Global = True
	Set obj = obj_regexp.Execute(invalue)
	Set obj_regexp = Nothing

End Sub

Function GetValue(invalue,default)

	Dim outvalue
	outvalue = Request.QueryString(invalue)
	If IsNull(outvalue) OR outvalue = "" Then
		outvalue = Request.Form(invalue)
		If IsNull(outvalue) OR outvalue = "" Then outvalue = default
	End If
	GetValue = outvalue
	
End Function

' Check if value is empty or not
Function NotEmpty(invalue)

	Dim outvalue
	
	If isnull(invalue) Then 
		outvalue = False
	ElseIf invalue = "" Then 
		outvalue = False
	Else
		outvalue = True
	End If
	
	NotEmpty = outvalue

End Function

Function ReplaceIfTrue(invalue,toreplace,replacevalue,found)

	Dim outvalue
	
	If found And NotEmpty(toreplace) And NotEmpty(replacevalue) Then
		outvalue = Replace(invalue,toreplace,replacevalue)
	Else
		outvalue = Replace(invalue,toreplace,"")
	End If

	ReplaceIfTrue = outvalue
	
End Function

Sub SplitValue(invalue,outarray,delimiter)

	Dim arr
	outarray = Split(invalue,delimiter)

End Sub

Function StripHTML(invalue)
'Strips the HTML tags from strHTML

	Dim obj_regexp, outvalue
	Set obj_regexp = New Regexp

	obj_regexp.IgnoreCase = True
	obj_regexp.Global = True
	obj_regexp.Pattern = "<(.|\n)+?>"

	'Replace all HTML tag matches with the empty string
	outvalue = obj_regexp.Replace(invalue, "")
	
	'Replace all < and > with &lt; and &gt;
	outvalue = Replace(outvalue, "<", "&lt;")
	outvalue = Replace(outvalue, ">", "&gt;")
	
	stripHTML = outvalue    'Return the value of strOutput
	
	Set obj_regexp = Nothing
	
End Function

Function ValueInArray(invalue,inarray)

	Dim outvalue,i
	
	If isArray(inarray) Then
		If Ubound(inarray) > 0 Then
			For i = 0 to Ubound(inarray)
				If CStr(invalue) = inarray(i) Then outvalue = True
			Next
		Else
			outvalue = True
		End If
	Else
		If Not NotEmpty(inarray) Then
			outvalue = True
		ElseIf NotEmpty(inarray) AND inarray = invalue Then
			outvalue = True
		Else
			outvalue = False
		End If
	End If

	ValueInArray = outvalue

End Function

Function ValueInArray_FALSE(invalue,inarray)

	Dim outvalue,i
	
	If isArray(inarray) Then
		If Ubound(inarray) > 0 Then
			For i = 0 to Ubound(inarray)
				If CStr(invalue) = inarray(i) Then outvalue = True
			Next
		Else
			outvalue = False
		End If
	Else
		If invalue = inarray Then
			outvalue = True
		Else
			outvalue = False
		End If
	End If
	
	ValueInArray_FALSE = outvalue

End Function
%>