<%
' *******************************************************************************
' AtomatiCMS
' Filename - acmsf_users.asp
' Summary  - User related functions and subroutines
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

Function ValidUser()
	
	Dim outvalue
	If GetCookie("username") = "" Then
		outvalue = False
	Else
		outvalue = True
	End If
	ValidUser = outvalue

End Function

Sub ValidateUser(access)
	
	If Not ValidUser Then 
		LogoutUser
		Response.Redirect "."
	End If
	
	If c_SUPERONLYACCESS = "" Then SetError GetLanguage("lang_permissiondenied"),GetReferPage
	If access = "" Then 
		Response.Cookies("acms").Expires = DateAdd("n",60,Now())
		Exit Sub
	End If
	If Not CheckUserPermissions(access) Then 
		SetError GetLanguage("lang_permissiondenied"),GetReferPage
	Else
		Response.Cookies("acms").Expires = DateAdd("n",60,Now())
	End If
	
End Sub

Function CheckUserPermissions(access)

	Dim arr_accessareas
	Dim i, outvalue
	
	outvalue = False
	If GetCookie("super") Then
		outvalue = True
	Else
		arr_accessareas = Split(GetCookie("accessareas"),",")
		For i = 0 To Ubound(arr_accessareas)
			If CStr(access) = CStr(arr_accessareas(i)) Then outvalue = True
		Next
	End If
	CheckUserPermissions = outvalue

End Function

Sub LogoutUser()
	
	Dim cookie
	
	For Each cookie in Request.Cookies("acms")
		Response.Cookies("acms")(cookie) = ""
	Next
	Response.Cookies("acms").Expires = DateAdd("d",-1,Now())

End Sub
%>