<%
' *******************************************************************************
' AtomatiCMS
' Filename - acmsi_pages.asp
' Summary  - Special functions and subroutines called from pages admin
' Version  - 0.7B
' Updated  - 28 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

Function GeneratePage(pageid,generatemode)

	Dim rs
	Dim str_templatefile, int_templatedb, str_filename, str_pagekeyword
	Dim str_contentbody
	Dim i
	
	' Get page information and generate error if no pages found
	ExecuteRecordset q_SelectTable("filename,template_db,template_file,keyword","acmstbl_pages","","","id",pageid,"number"), conn, rs
	If Not rs.EOF Then
		str_templatefile = rs("template_file")
		int_templatedb = rs("template_db")
		str_filename = rs("filename")
		str_pagekeyword = rs("keyword")
	Else
		CloseRecordset rs
		SetError GetLanguage("lang_pagenotfound"),"acms_pagelist.asp"
		Exit Function
	End If
	CloseRecordset rs
		
	' Get content of template
	If NotEmpty(str_templatefile) Then
		str_contentbody = ReadFile("templates" & "/" & str_templatefile)
	ElseIf int_templatedb > 0 Then
		ExecuteRecordset q_SelectTable("snippet","acmstbl_snippets","","","id",int_templatedb,"number"), conn, rs
		If Not rs.EOF Then str_contentbody = rs("snippet")
		CloseRecordset rs
	Else
		Exit Function
	End If
	
	' Check if template allows for content, then call to generate page content
	If Instr(str_contentbody,"{acms:content}") > 0 Then	
		str_contentbody = Replace(str_contentbody,"{acms:content}","{acms:content_0}")
		GeneratePageContent 0, int_pageid, str_pagekeyword, str_contentbody, ""
		str_contentbody = Replace(str_contentbody,"{acms:content_0}","")
	End If
	
	' Generate content based on tags, loop until c_GENERATEPAGELOOP to prevent infinite looping
	For i = 0 To c_GENERATEPAGELOOP
		GenerateHeadContent pageid, str_contentbody
		GenerateSnippetContent pageid, str_pagekeyword, str_contentbody
		GenerateReservedContent pageid, str_pagekeyword, str_contentbody 
		GenerateDatabaseContent pageid, str_pagekeyword, str_contentbody 
		GenerateModuleContent pageid, str_pagekeyword, str_contentbody
	Next
	
	If generatemode AND NotEmpty(str_filename) Then 
		WriteFile str_filename, str_contentbody
		q_SetModifiedPage conn,int_pageid,False
	Else
		WriteApplication "page_" & str_pagekeyword, str_contentbody
		q_SetModifiedPage conn,int_pageid,False
	End If
	GeneratePage = str_contentbody

End Function

' Recursive subroutine that will add content of child to parent,
' if {acms:content} is added to the parent content
Sub GeneratePageContent(parentid,pageid,pagekeyword,body,setcontentname)

	Dim int_contentid, str_contentbody
	Dim str_contentkey, int_contentkeylen, int_contentpos
	Dim str_contenttop, str_contentbottom
	Dim rs
	If NotEmpty(setcontentname) Then
		ExecuteRecordset q_SelectTable("*","acmstbl_content","ordinal","(hide=" & GetBoolean(False) & ") AND (pageid=" & pageid & ") AND (setcontentname='" & setcontentname & "')","parentid",parentid,"number"), conn, rs
	Else
		ExecuteRecordset q_SelectTable("*","acmstbl_content","ordinal","(hide=" & GetBoolean(False) & ") AND (pageid=" & pageid & ") AND (setcontentname='' OR setcontentname IS NULL)","parentid",parentid,"number"), conn, rs
	End If
	Do Until rs.EOF
		int_contentid = rs("id")
		str_contentbody = rs("contentbody")
		GenerateSnippetContent pageid, pagekeyword, str_contentbody
		If IsNull(str_contentbody) Then str_contentbody = ""
		str_contentkey = "{acms:content_" & int_contentid & "}"
		' If no {acms:content} is added to the body, the child content will be appended to the end
		If Instr(str_contentbody,"{acms:content}") > 0 Then
			str_contentbody = Replace(str_contentbody,"{acms:content}",str_contentkey)
		Else
			str_contentbody = str_contentbody & str_contentkey
		End If
		' Get position of where to put content
		int_contentpos = Instr(body,"{acms:content_" & parentid & "}")
		' Get length of parent key
		int_contentkeylen = Len(Cstr("{acms:content_" & parentid & "}"))
		If int_contentpos > 0 Then 
			str_contenttop = Left(body,int_contentpos-1)
			str_contentbottom = Mid(body,int_contentpos,Len(body)-Len(str_contenttop))
			body = str_contenttop & "<a name=""content_" & int_contentid & """></a>" & str_contentbody & str_contentbottom
		End If
		GeneratePageContent int_contentid, pageid, pagekeyword, body, setcontentname
		rs.MoveNext
		body = Replace(body,"{acms:content_" & int_contentid & "}",vbCrLf)
	Loop
	CloseRecordset rs

End Sub

' Add content of "headtags" to generated page
Sub GenerateHeadContent(pageid,body)

	Dim rs
	ExecuteRecordset q_SelectTable("headtags","acmstbl_pages","","","id",pageid,"number"), conn, rs
	If Not rs.EOF Then
		body = Replace(body,"{acms:head}",rs("headtags"))
	Else
		body = Replace(body,"{acms:head}","")
	End If
	CloseRecordset rs

End Sub

' Add module content
Sub GenerateModuleContent(pageid,pagekeyword,body)

	Dim obj_matches, obj_match
	Dim fs
	Dim str_result, str_match, str_module, str_sessionid, date_now
	Dim str_calledfilename
	Dim arr_match
	Dim bln_found
	Dim rs, rs_mod
	Dim i
	
	While (HasACMSExpression(body,"acms:mod") > 0) OR i > c_GENERATECONTENTLOOP
	
		i = i + 1
		GetRegExpMatches "\{acms:mod\([a-zA-Z0-9]*\)(.*?)\}", body, obj_matches
		For Each obj_match in obj_matches
			bln_found = False
			str_match = GetKey("mod",obj_match)
			ExecuteRecordset q_SelectTable("calledfilename","acmstbl_modules","","disabled=" & GetBoolean(False),"keyword",str_match,"string"), conn, rs
			If Not rs.EOF Then
				str_calledfilename = rs("calledfilename")
			Else
				str_calledfilename = str_match
			End If
			CloseRecordset rs
			If NotEmpty(str_calledfilename) Then
				OpenFSO fs
				If fs.FileExists(Server.MapPath(str_calledfilename)) Then
					WriteSession "modpagekeyword", pagekeyword
					WriteSession "modtag", obj_match
					Server.Execute str_calledfilename
					str_module = GetSession("mod")
					RemoveSession "mod"
					RemoveSession "modtag"
					RemoveSession "modpagekeyword"
				Else
					str_module = ""
				End If
				CloseFSO fs
			Else
				str_module = ""
			End If
			
			str_result = lcase(obj_match.SubMatches(0))
			GetCommaRecords str_result, "notinpages", arr_match
			bln_found = ValueInArray_FALSE(pagekeyword,arr_match)
			If Not bln_found Then
				GetCommaRecords str_result, "pages", arr_match
				bln_found = ValueInArray(pagekeyword,arr_match)
			Else
				bln_found = False
			End If
			body = ReplaceIfTrue(body,obj_match,str_module,bln_found)
		Next
		
	Wend

End Sub

' Snippets allow one property of pages, in the form of pages(page keywords separated by commas)
Sub GenerateSnippetContent(pageid,pagekeyword,body)

	Dim obj_matches, obj_match
	Dim str_result, str_match, str_snippet
	Dim arr_match
	Dim bln_found
	Dim rs, fs, i
	
	i = 0
	While HasACMSExpression(body,"acms:file") > 0 OR i > c_GENERATECONTENTLOOP
	
		i = i + 1
		GetRegExpMatches "\{acms:file\(.[^\(\)]*\)(.*?)\}", body, obj_matches
		For Each obj_match in obj_matches
			bln_found = False
			str_match = GetKey("file",obj_match)
			OpenFSO fs
			str_snippet = ReadFile(str_match)
			CloseFSO fs
			str_result = lcase(obj_match.SubMatches(0))
			GetCommaRecords str_result, "notinpages", arr_match
			bln_found = ValueInArray_FALSE(pagekeyword,arr_match)
			If Not bln_found Then
				GetCommaRecords str_result, "pages", arr_match
				bln_found = ValueInArray(pagekeyword,arr_match)
			Else
				bln_found = False
			End If
			body = ReplaceIfTrue(body,obj_match,str_snippet,bln_found)
		Next
		
	Wend
	
	i = 0
	While HasACMSExpression(body,"acms:snp") > 0 OR i > c_GENERATECONTENTLOOP
	
		i = i + 1
		GetRegExpMatches "\{acms:snp\([a-zA-Z0-9]*\)(.*?)\}", body, obj_matches
		For Each obj_match in obj_matches
			bln_found = False
			str_match = GetKey("snp",obj_match)
			ExecuteRecordset q_SelectTable("snippet","acmstbl_snippets","","(hide=" & GetBoolean(False) & ") AND (istemplate=" & GetBoolean(False) & ")","keyword",str_match,"string"), conn, rs
			If Not rs.EOF Then
				str_snippet = rs("snippet")
			Else
				str_snippet = ""
			End If
			CloseRecordset rs
			str_result = lcase(obj_match.SubMatches(0))
			GetCommaRecords str_result, "notinpages", arr_match
			bln_found = ValueInArray_FALSE(pagekeyword,arr_match)
			If Not bln_found Then
				GetCommaRecords str_result, "pages", arr_match
				bln_found = ValueInArray(pagekeyword,arr_match)
			Else
				bln_found = False
			End If
			body = ReplaceIfTrue(body,obj_match,str_snippet,bln_found)
		Next
		
	Wend

End Sub

' Snippets allow one property of pages, in the form of pages(page keywords separated by commas)
Sub GenerateDatabaseContent(pageid,pagekeyword,body)

	Dim obj_matches, obj_match
	Dim str_field, var_fieldvalue, str_result
	Dim str_table, str_pk, var_pkvalue
	Dim arr_match
	Dim bln_found
	Dim rs, i
	
	While HasACMSInnerExpression(body,"acms:dat") > 0 OR i > c_GENERATECONTENTLOOP

		i = i + 1
		GetRegExpMatches "\[acms:dat='[a-zA-Z0-9_-]*'(.*?)\]", body, obj_matches
		For Each obj_match in obj_matches
			bln_found = False
			str_field = GetInnerKey("dat",obj_match)
			str_table = GetInnerFirstRecord(obj_match,"tbl")
			
			If NotEmpty(str_table) Then
			
				str_pk = GetInnerFirstRecord(obj_match,"pk")
				var_pkvalue = GetInnerFirstRecord(obj_match,"pkvalue")
				If NotEmpty(str_pk) AND NotEmpty(var_pkvalue) Then
					If IsNumeric(var_pkvalue) Then
						ExecuteRecordset q_SelectTable(str_field,str_table,"","",str_pk,var_pkvalue,"number"), conn, rs
					Else
						ExecuteRecordset q_SelectTable(str_field,str_table,"","",str_pk,CStr(var_pkvalue),"string"), conn, rs
					End If
					If Not rs.EOF Then
						var_fieldvalue = rs(0)
					Else
						var_fieldvalue = ""
					End If
					CloseRecordset rs
				Else
					var_fieldvalue = ""
				End If
				
			Else
				ExecuteRecordset q_SelectTable(str_field,"acmstbl_pages","","","id",pageid,"number"), conn, rs
				If Not rs.EOF Then
					var_fieldvalue = rs(0)
				Else
					var_fieldvalue = ""
				End If
				CloseRecordset rs
			End If
			
			str_result = obj_match.SubMatches(0)
			GetInnerCommaRecords obj_match.SubMatches(0), "pages", arr_match
			bln_found = ValueInArray_FALSE(pagekeyword,arr_match)
			If Not bln_found Then
				GetInnerCommaRecords str_result, "pages", arr_match
				bln_found = ValueInArray(pagekeyword,arr_match)
			Else
				bln_found = False
			End If
			body = ReplaceIfTrue(body,obj_match,var_fieldvalue,bln_found)
		Next
		
	Wend

End Sub

Sub GenerateReservedContent(pageid,pagekeyword,body)

	Dim obj_matches, obj_match, arr_pages, str_result
	Dim str_key, bln_found
	Dim rs, i
	
	Dim str_setcontent, str_setcontentname						' Set content variables
	Dim str_css, str_cssfile, str_cssmedia						' CSS variables
	Dim str_title, str_titlevalue								' Title
	Dim str_script, str_scriptmatches, arr_scriptkeys			' Script
	Dim str_other, str_othermatches, arr_otherkeys				' Other
	
	While HasACMSExpression(body,"acms:res") > 0 OR i > c_GENERATECONTENTLOOP
	
		i = i + 1
		GetRegExpMatches "\{acms:res\([a-zA-Z0-9]*\)(.*?)\}", body, obj_matches
		For Each obj_match in obj_matches
			bln_found = False
			str_key = GetKey("res",obj_match)
			str_result = obj_match.SubMatches(0)
			Select Case lcase(str_key)
			
				' Set content
				Case "content"
					str_setcontentname = GetFirstRecord(obj_match,"name")
					GetCommaRecords str_result, "pages", arr_pages
					bln_found = ValueInArray_FALSE(pagekeyword,arr_pages)
					If Not bln_found Then
						GetCommaRecords str_result, "pages", arr_pages
						bln_found = ValueInArray(pagekeyword,arr_pages)
					Else
						bln_found = False
					End If
					
					If bln_found Then
						ExecuteRecordset q_SelectTable("id,contentbody","acmstbl_content","","(setcontentname='" & str_setcontentname & "') AND (ordinal=-1) AND (hide=" & GetBoolean(False) & ")","pageid",pageid,"number"), conn, rs
						If Not rs.EOF Then
							str_setcontent = rs("contentbody")
							If Instr(rs("contentbody"),"{acms:content}") > 0 Then 
								body = Replace(body,obj_match,"{acms:content_0}")
								GeneratePageContent 0, pageid, pagekeyword, body, str_setcontentname
								body = Replace(body,"{acms:content_0}","")
							Else
								body = Replace(body,obj_match,"{acms:content_0}")
								GeneratePageContent 0, pageid, pagekeyword, body, str_setcontentname
								body = Replace(body,"{acms:content_0}","")
							End If
						End If
						CloseRecordset rs
					Else
						If NotEmpty(body) Then body = Replace(body,obj_match,"")
					End If
					
				' CSS
				Case "css"
					str_css = "<link type=""text/css"" rel=""stylesheet"""
					str_cssfile = GetFirstRecord(obj_match,"file")
					str_css = str_css & " href=""" & str_cssfile & """"

					str_cssmedia = GetFirstRecord(obj_match,"media")
					If NotEmpty(str_cssmedia) Then str_css = str_css & " media=""" & str_cssmedia & """"

					str_css = str_css & " />"

					GetCommaRecords str_result, "pages", arr_pages
					bln_found = ValueInArray_FALSE(pagekeyword,arr_pages)
					If Not bln_found Then
						GetCommaRecords str_result, "pages", arr_pages
						bln_found = ValueInArray(pagekeyword,arr_pages)
					Else
						bln_found = False
					End If
					body = ReplaceIfTrue(body,obj_match,str_css,bln_found)
					
				' title
				Case "title"
					str_titlevalue = GetFirstRecord(obj_match,"value")
					str_title = "<title>" & str_titlevalue & "</title>"
					
					GetCommaRecords str_result, "pages", arr_pages
					bln_found = ValueInArray_FALSE(pagekeyword,arr_pages)
					If Not bln_found Then
						GetCommaRecords str_result, "pages", arr_pages
						bln_found = ValueInArray(pagekeyword,arr_pages)
					Else
						bln_found = False
					End If
					body = ReplaceIfTrue(body,obj_match,str_title,bln_found)
					
				' script
				Case "script"
					str_script = "<script"
					GetRegExpMatches "\s(.*?)\((.*?)\)", obj_match, arr_scriptkeys
					For each str_scriptmatches in arr_scriptkeys
						str_script = str_script & " " & str_scriptmatches.SubMatches(0) & "=""" & str_scriptmatches.SubMatches(1) & """"
					Next
					str_script = str_script & "></script>"
					GetCommaRecords str_result, "pages", arr_pages
					bln_found = ValueInArray_FALSE(pagekeyword,arr_pages)
					If Not bln_found Then
						GetCommaRecords str_result, "pages", arr_pages
						bln_found = ValueInArray(pagekeyword,arr_pages)
					Else
						bln_found = False
					End If
					body = ReplaceIfTrue(body,obj_match,str_script,bln_found)
					
				Case Else
					str_other = "<" & GetFirstRecord(obj_match,"res")
					GetRegExpMatches "\s(.*?)\((.*?)\)", obj_match, arr_otherkeys
					For each str_othermatches in arr_otherkeys
						str_other = str_other & " " & str_othermatches.SubMatches(0) & "=""" & str_othermatches.SubMatches(1) & """"
					Next
					str_other = str_other & " />"
					GetCommaRecords str_result, "pages", arr_pages
					bln_found = ValueInArray_FALSE(pagekeyword,arr_pages)
					If Not bln_found Then
						GetCommaRecords str_result, "pages", arr_pages
						bln_found = ValueInArray(pagekeyword,arr_pages)
					Else
						bln_found = False
					End If
					body = ReplaceIfTrue(body,obj_match,str_other,bln_found)
					
			End Select
		Next
	Wend
	
End Sub
%>